/* Scripts for the collapsible sidebar */

/* Show left tab */
function showLeftTab(name) {
 var f = $$('div#leftmenu .collapse_tab-content');
 for(var i=0; i<f.length; i++){
   Element.hide(f[i]);
 }
 var f = $$('div.collapse_tabs a');
 for(var i=0; i<f.length; i++){
  Element.removeClassName(f[i], "selected");
 }
 Element.show('collapse_tab-content-' + name);
 Element.addClassName('collapse_tab-' + name, "selected");

 return false;
}

/* Function to allow the projects to show up as a tree */
function showHide(EL,PM) 
{
	var els = document.getElementById('projects-nested').getElementsByTagName('tr');
	var elsLen = els.length;
	var pattern = new RegExp("(^|\\s)"+EL+"(\\s|$)");
	var cpattern = new RegExp("span");
	var expand = new RegExp("open");
	var collapse = new RegExp("closed");
	var hide = new RegExp("hide");
	var spanid = PM;
	var classid = new RegExp("junk");
	var oddeventoggle = 0;
	for (i = 0; i < elsLen; i++)
	{
		
		if(cpattern.test(els[i].id))
		{
			var tmpspanid = spanid;
			var tmpclassid = classid;
			spanid = els[i].id;
			classid = spanid;
			classid = classid.match(/(\w+)span/)[1];
			classid = new RegExp(classid);
			if(tmpclassid.test(els[i].className) && (tmpspanid.toString() != PM.toString()))
			{
				if(collapse.test(document.getElementById(tmpspanid).className))
				{
					spanid = tmpspanid;
					classid = tmpclassid;
				}			
			}
		}
		
		if ( pattern.test(els[i].className) ) {

		  var cnames = els[i].className;
		  
		  cnames = cnames.replace(/hide/g,'');
		  
		  if (expand.test(document.getElementById(PM).className))
		  {
				cnames += ' hide';			
		  }
		  else
		  {		
				if((spanid.toString() != PM.toString()) &&
				  (classid.test(els[i].className)))
				{
					  if(collapse.test(document.getElementById(spanid).className))
					  {
						  cnames += ' hide';		 
					  }					  
				}
		  }
		   	  
		  els[i].className = cnames;
		  
		}
		
		if(!(hide.test(els[i].className)))
		{
			var cnames = els[i].className;	
			cnames = cnames.replace(/odd/g,'');
			cnames = cnames.replace(/even/g,'');			
		  		
			/*if(oddeventoggle == 0)
			{
				cnames += ' odd';
			}
			else
			{
				cnames += ' even';
			}*/
			
			oddeventoggle ^= 1;			
			els[i].className = cnames;
		}	
	}
	if (collapse.test(document.getElementById(PM).className))
	{
		var cnames = document.getElementById(PM).className;
		cnames = cnames.replace(/closed/,'open');
		document.getElementById(PM).className = cnames;
	}
	else
	{
		var cnames = document.getElementById(PM).className;
		cnames = cnames.replace(/open/,'closed');
		document.getElementById(PM).className = cnames;
	}
}

function setHeightById() {
	var n = setHeightById.arguments.length;
	var args = setHeightById.arguments;
	
	if(n>1)
	switch (isInteger(args[0]))
	{
         case true:
            for(i=1; i < n; i++) {	
				element = document.getElementById(args[i]);			
				if(element != null) element.style.height = parseInt(args[0]) + "px";
			}	
            break;
         case false:
		 	var element;
			var maxHeight = 0;
			for(i=0; i < n; i++) {				
				element = document.getElementById(args[i]);
				if(element != null)
					if(maxHeight < parseInt(getElementHeight(element))) maxHeight = parseInt(getElementHeight(element));
			}	
			for(i=0; i < n; i++) {	
				element = document.getElementById(args[i]);			
				if(element != null) element.style.height = maxHeight + "px";
			}			 
    }
}
function isInteger(s) { // String s
	var i;
	for (i = 0; i < s.length; i++) {
		var c = s.charAt(i);
		if (!((c >= "0") && (c <= "9"))) return false;
	}
	return true;
}

function getElementHeight(element) {	
	if(element == null) return 0;
	if(element.clientHeight) {
		return element.clientHeight;
	}
	else {
		if(element.offsetHeight) {
			return element.offsetHeight;
		}
	}
	return 10;
}


/* HELPERS COOKIE taken from http://www.lalit.org/wordpress/wp-content/uploads/2008/06/cookiejar.js */

/**
 * Javascript code to store data as JSON strings in cookies. 
 * It uses prototype.js 1.5.1 (http://www.prototypejs.org)
 * 
 * Author : Lalit Patel
 * Website: http://www.lalit.org/lab/jsoncookies
 * License: Creative Commons Attribution-ShareAlike 2.5
 *          http://creativecommons.org/licenses/by-sa/2.5/
 * Version: 0.4
 * Updated: Aug 11, 2007 10:09am
 * 
 * Chnage Log:
 *   v 0.4
 *   -  Removed a extra comma in options (was breaking in IE and Opera). (Thanks Jason)
 *   -  Removed the parameter name from the initialize function
 *   -  Changed the way expires date was being calculated. (Thanks David)
 *   v 0.3
 *   -  Removed dependancy on json.js (http://www.json.org/json.js)
 *   -  empty() function only deletes the cookies set by CookieJar
 */

var CookieJar = Class.create();

CookieJar.prototype = {

	/**
	 * Append before all cookie names to differntiate them.
	 */
	appendString: "__CJ_",

	/**
	 * Initializes the cookie jar with the options.
	 */
	initialize: function(options) {
		this.options = {
			expires: 3600,		// seconds (1 hr)
			path: '',			// cookie path
			domain: '',			// cookie domain
			secure: ''			// secure ?
		};
		Object.extend(this.options, options || {});

		if (this.options.expires != '') {
			var date = new Date();
			date = new Date(date.getTime() + (this.options.expires * 1000));
			this.options.expires = '; expires=' + date.toGMTString();
		}
		if (this.options.path != '') {
			this.options.path = '; path=' + escape(this.options.path);
		}
		if (this.options.domain != '') {
			this.options.domain = '; domain=' + escape(this.options.domain);
		}
		if (this.options.secure == 'secure') {
			this.options.secure = '; secure';
		} else {
			this.options.secure = '';
		}
	},

	/**
	 * Adds a name values pair.
	 */
	put: function(name, value) {
		name = this.appendString + name;
		cookie = this.options;
		var type = typeof value;
		switch(type) {
		  case 'undefined':
		  case 'function' :
		  case 'unknown'  : return false;
		  case 'boolean'  : 
		  case 'string'   : 
		  case 'number'   : value = String(value.toString());
		}
		var cookie_str = name + "=" + escape(Object.toJSON(value));
		try {
			document.cookie = cookie_str + cookie.expires + cookie.path + cookie.domain + cookie.secure;
		} catch (e) {
			return false;
		}
		return true;
	},

	/**
	 * Removes a particular cookie (name value pair) form the Cookie Jar.
	 */
	remove: function(name) {
		name = this.appendString + name;
		cookie = this.options;
		try {
			var date = new Date();
			date.setTime(date.getTime() - (3600 * 1000));
			var expires = '; expires=' + date.toGMTString();
			document.cookie = name + "=" + expires + cookie.path + cookie.domain + cookie.secure;
		} catch (e) {
			return false;
		}
		return true;
	},

	/**
	 * Return a particular cookie by name;
	 */
	get: function(name) {
		name = this.appendString + name;
		var cookies = document.cookie.match(name + '=(.*?)(;|$)');
		if (cookies) {
			return (unescape(cookies[1])).evalJSON();
		} else {
			return null;
		}
	},

	/**
	 * Empties the Cookie Jar. Deletes all the cookies.
	 */
	empty: function() {
		keys = this.getKeys();
		size = keys.size();
		for(i=0; i<size; i++) {
			this.remove(keys[i]);
		}
	},

	/**
	 * Returns all cookies as a single object
	 */
	getPack: function() {
		pack = {};
		keys = this.getKeys();

		size = keys.size();
		for(i=0; i<size; i++) {
			pack[keys[i]] = this.get(keys[i]);
		}
		return pack;
	},

	/**
	 * Returns all keys.
	 */
	getKeys: function() {
		keys = $A();
		keyRe= /[^=; ]+(?=\=)/g;
		str  = document.cookie;
		CJRe = new RegExp("^" + this.appendString);
		while((match = keyRe.exec(str)) != undefined) {
			if (CJRe.test(match[0].strip())) {
				keys.push(match[0].strip().gsub("^" + this.appendString,""));
			}
		}
		return keys;
	}
};

/* Helpers for left menu toggeling */
Effect.BlindLeft = function(element) {
  element = $(element);
  element.makeClipping();
  return new Effect.Scale(element, 0,
    Object.extend({ scaleContent: false, 
      scaleY: false, 
      restoreAfterFinish: true,
      afterFinishInternal: function(effect) {
        effect.element.hide().undoClipping();
      } 
    }, arguments[1] || { })
  );
};

Effect.BlindRight = function(element) {
  element = $(element);
  var elementDimensions = element.getDimensions();
  return new Effect.Scale(element, 100, Object.extend({ 
    scaleContent: false, 
    scaleY: false,
    scaleFrom: 0,
    scaleMode: {originalHeight: elementDimensions.height, originalWidth: elementDimensions.width},
    restoreAfterFinish: true,
    afterSetup: function(effect) {
      effect.element.makeClipping().setStyle({width: '0px'}).show(); 
    },  
    afterFinishInternal: function(effect) {
      effect.element.undoClipping();
    }
  }, arguments[1] || { }));
};

Effect.PAIRS.horizontalslide = ['BlindRight', 'BlindLeft'];

function toggle_leftMenu(element) {
  element = $(element);
   
  var jar = new CookieJar({
    expires:3600,   // seconds
    path: '/'
  });
  
  jar.put('status_leftMenu', !element.visible());
  Effect.toggle(element, 'horizontalslide', {duration:0.2});
  
}

Event.observe(window, 'load', function() {
  var jar = new CookieJar({                                                                                                                                              
    expires:3600,   // seconds                                                                                                                                           
    path: '/'
  });
  var el = jar.get('status_leftMenu');

  if (el == "true") {
  } else {
	if(document.getElementById('leftmenu-contents') != null) $('leftmenu-contents').hide();
  }
});
